unit uTCronico;

interface

uses
  Windows, Messages, SysUtils, Classes,  WSockets;

const CONST_Progver='v0.94c';
      CONST_Progname='CronIco';
      CONST_Author='(w)2000 by Dennis D. Spreen (info@spreendigital.de)';
      Version   =CONST_Progname+' '+CONST_Progver+' '+CONST_Author;
      TCPVersion=CONST_Progname+'/TCP '+CONST_Progver+' '+CONST_Author;
      CRLF=#$0D#$0A;

      DEF_TCPPort    = 7059;
      DEF_INTERVAL   = 10*1000*60;
      DEF_RECONNECT  = 60*1000;
      DEF_TIMEFORMAT = 'dd.mm.yyyy_hh:nn:ss';



type
TTimer = class(TComponent)
  private
    FInterval: Cardinal;
    FWindowHandle: HWND;
    FOnTimer: TNotifyEvent;
    FEnabled: Boolean;
    procedure UpdateTimer;
    procedure SetEnabled(Value: Boolean);
    procedure SetInterval(Value: Cardinal);
    procedure SetOnTimer(Value: TNotifyEvent);
    procedure WndProc(var Msg: TMessage);
  protected
    procedure Timer; dynamic;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Enabled: Boolean read FEnabled write SetEnabled default True;
    property Interval: Cardinal read FInterval write SetInterval default 1000;
    property OnTimer: TNotifyEvent read FOnTimer write SetOnTimer;
  end;



type TWindowEntry = class
      Wnd:Hwnd;
      WndName:string;
      Classname:String;
      ParentWnd:Hwnd;
      ParentName:string;
     end;

type TWindowLister = class
      procedure GetWindows(OnGetWindow:TNotifyEvent);
      procedure GetChildWindows(hwndNext:Hwnd;OnGetWindow:TNotifyEvent);
     end;

type TWinCronWindowEntry = class
      Wnd:Hwnd;
      WndName:string;
      ClassName:string;
      Hook:HHook;
      ThreadProcessID:DWord;
      status:string;
      state:integer;
      prevstate:integer;
      CheckboxContinueOnError:boolean;
      CheckboxLog:boolean;
      CheckboxNoUpdate:boolean;
      CrontabString,LogfileString:string;
      constructor Create;
      destructor destroy;override;
     end;

type TCronico=class
      WinCrons:Tlist;
      multiple:boolean;
      mycurrenthandle:Hwnd;
      CurrentWincron:TWinCronWindowEntry;
      WindowLister:TWindowLister;
      TCPServer:TTCPServer;
      isRunning:boolean;
      TCPPort:integer;
      ReConnectTimer:TTimer;
      DateFormat:String;
      ReConnectInterval:integer;
      MTimer:TTimer;
      BindIP:string;
      CheckTimer:TTimer;
      onCheckTimer:TNotifyEvent;
      constructor Create(currenthandle:hwnd);
      destructor destroy;override;
      procedure Run;
      procedure GetWinCrons;
      procedure GetWindowEntry(Sender:TObject);
      procedure GetChildWindowEntry(Sender:TObject);
      procedure Hide(WinCronWindowEntry:TWinCronWindowEntry);
      procedure Show(WinCronWindowEntry:TWinCronWindowEntry);
      procedure Kill(WinCronWindowEntry:TWinCronWindowEntry);
      procedure ShowAll;
      procedure HideAll;
      procedure KillAll;
      procedure OpenServer;
      procedure StopListen;
      procedure StartListen;
      procedure TCPServerAccept(Sender: TObject; Socket: integer);
      procedure ReConnectTimerTimer(Sender:TObject);
      procedure MinimizeTimerTimer(Sender:TObject);
      procedure CheckTimerTimer(Sender:TObject);
      function DateTimeToHex(mtime:TDateTime):string;
      function HexToDateTime(hex:string):TDateTime;
      procedure Configure(parameter,value:String);
     end;


implementation

uses forms;



{ TTimer }

constructor TTimer.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FEnabled := True;
  FInterval := 1000;
  FWindowHandle := AllocateHWnd(WndProc);
end;

destructor TTimer.Destroy;
begin
  FEnabled := False;
  UpdateTimer;
  DeallocateHWnd(FWindowHandle);
  inherited Destroy;
end;

procedure TTimer.WndProc(var Msg: TMessage);
begin
  with Msg do
    if Msg = WM_TIMER then
      try
        Timer;
      except
        //Application.HandleException(Self);
      end
    else
      Result := DefWindowProc(FWindowHandle, Msg, wParam, lParam);
end;

procedure TTimer.UpdateTimer;
begin
  KillTimer(FWindowHandle, 1);
  if (FInterval <> 0) and FEnabled and Assigned(FOnTimer) then
    if SetTimer(FWindowHandle, 1, FInterval, nil) = 0 then
      //raise EOutOfResources.Create(SNoTimers);
end;

procedure TTimer.SetEnabled(Value: Boolean);
begin
  if Value <> FEnabled then
  begin
    FEnabled := Value;
    UpdateTimer;
  end;
end;

procedure TTimer.SetInterval(Value: Cardinal);
begin
  if Value <> FInterval then
  begin
    FInterval := Value;
    UpdateTimer;
  end;
end;

procedure TTimer.SetOnTimer(Value: TNotifyEvent);
begin
  FOnTimer := Value;
  UpdateTimer;
end;

procedure TTimer.Timer;
begin
  if Assigned(FOnTimer) then FOnTimer(Self);
end;














var   fGetWindowEvent:TNotifyEvent;

function EnumWindowsProc(hwndNext : HWnd; var lpara : LongInt):Bool;stdcall;
var
 P      : array[0..255] of Char;
 hPar:HWnd;
 WindowEntry:TWindowEntry;
begin
 Result := True;
 if hwndNext <> 0 then begin
  WindowEntry:=TWindowEntry.Create;
  WindowEntry.Wnd:=HwndNext;
  GetWindowText(hwndNext, P, 255);
  WindowEntry.WndName:=string(p);
  GetClassName(hwndNext, P, 255);
  WindowEntry.Classname:=string(p);
  hPar := GetWindowLong(hwndNext,GWL_HWNDPARENT);
  WindowEntry.ParentWnd:=hPar;
  GetWindowText(hPar, P, 255);
  WindowEntry.ParentName:=string(p);
  if assigned(fGetWindowEvent) then fGetWindowEvent(WindowEntry);
  WindowEntry.Free;
 end;
end;



procedure TWindowLister.GetWindows(OnGetWindow:TNotifyEvent);
begin
 fGetWindowEvent:=OnGetWindow;
 EnumWindows(@EnumWindowsProc,0);
end;


procedure TWindowLister.GetChildWindows(hwndNext:Hwnd;OnGetWindow:TNotifyEvent);
begin
 fGetWindowEvent:=OnGetWindow;
 EnumChildWindows(hwndNext,@EnumWindowsProc,0);
end;

constructor TWinCronWindowEntry.Create;
begin
 inherited Create;
 State:=-1;
 prevState:=-1;
end;

destructor TWinCronWindowEntry.destroy;
begin
 inherited Destroy;
end;


constructor TCronico.Create;
begin
 inherited Create;
 mycurrenthandle:=currenthandle;
 isrunning:=false;
 multiple:=false;
 WindowLister:=TWindowLister.Create;
 WinCrons:=Tlist.Create;
 onCheckTimer:=NIL;
 BindIP:='';
 ReConnectInterval:=DEF_RECONNECT;
 TCPPort:=0; //7059;
 dateformat:=DEF_TIMEFORMAT;
 MTimer:=TTimer.Create(NIL);
 MTimer.Enabled:=false;
end;

procedure TCronIco.Run;
begin
 MTimer.Interval:=2000;
 MTimer.OnTimer:=MinimizeTimerTimer;
 CheckTimer:=TTimer.Create(nil);
 CheckTimer.OnTImer:=CheckTimerTimer;
 CheckTimer.Interval:=DEF_INTERVAL;
 CheckTimer.Enabled:=true;
 CheckTimerTimer(NIL);
end;


destructor TCronico.destroy;
begin
 MTimer.Free;
 ReConnectTimer.free;
 WindowLister.free;
 while (WinCrons.Count>0) do WinCrons.delete(0);
 WinCrons.free;
 TCPServer.free;
 inherited Destroy;
end;


procedure TCronico.GetWindowEntry(Sender:TObject);
var WindowEntry:TWindowEntry;
    WinCronWindowEntry:TWincronWindowEntry;
begin
 WindowEntry:=TWindowEntry(Sender);

 {if WindowEntry<>nil then
 writeln(windowentry.parentname+':'+WindowENtry.CLassName);}

 if WindowEntry<>nil then
 if WindowEntry.ParentName='WinCron' then
 begin
  if (WindowENtry.CLassName='ThunderRT6FormDC') or
     (WindowEntry.ClassName='ThunderRTForm') then
  begin
   WinCronWindowEntry:=TWinCronWindowEntry.Create;
   WinCronWindowEntry.Wnd:=WindowEntry.Wnd;
   WinCronWindowEntry.WndName:=WindowEntry.WndName;
   WinCronWindowEntry.ClassName:=WindowEntry.Classname;
   WinCrons.Add(WinCronWindowEntry)
  end;
 end
 else
 if (WindowEntry.Classname='TForm1') and
    (WindowEntry.Parentname='CronIco') and
    (WindowEntry.WndName='CronIco Instance') and
    (WindowEntry.Wnd<>mycurrenthandle) then
     isRunning:=true;
// showmessage(windowEntry.classname+' '+windowentry.WndName+' '+windowentry.ParentName);
end;


procedure TCronico.GetChildWindowEntry(Sender:TObject);
var WindowEntry:TWindowEntry;
    res:integer;
    Checked:boolean;
    s:string;
    c,b:integer;
begin
 WindowEntry:=TWindowEntry(Sender);
 if WindowEntry<>nil then
 begin

  if WindowEntry.classname='ThunderRT6CommandButton' then
  begin
   //showmessage(WindowEntry.
   SendMessage(WindowEntry.wnd,BM_CLICK,0,0);
   val (WindowEntry.WndName,b,c);
   if c<>0 then CurrentWincron.status:=WindowEntry.WndName
           else begin
                 CurrentWincron.prevstate:=CurrentWinCron.state;
                 CurrentWinCron.State:=b;
                 //ShowMessage(windowentry.classname+' '+IntToStr(b));
                end;
  end;


  if WindowEntry.classname='ThunderRT6CheckBox' then
   begin
     res:=SendMessage(WindowEntry.wnd,BM_GETSTATE,0,0);
     Checked:=(res=1);
     if uppercase(WindowEntry.WndName)='/CONTINUEONERROR' then CurrentWincron.CheckboxContinueOnError:=Checked;
     if uppercase(WindowEntry.WndName)='/LOG' then CurrentWincron.CheckboxLog:=Checked;
     if uppercase(WindowEntry.WndName)='/NOUPDATE' then CurrentWincron.CheckboxNoUpdate:=Checked;
    end;

  if WindowEntry.classname='ThunderRT6TextBox' then
   begin
    res:=SendMessage(WindowEntry.wnd,WM_GETTEXTLENGTH,0,0);
    setlength(s,res+1);
    SendMessage(WindowEntry.wnd,WM_GETTEXT,res+1,integer(@s[1]));
    while pos(#0,s)<>0 do delete(s,pos(#0,s),1);
    if CurrentWincron.LogFileString='' then CurrentWIncron.LogfileString:=s
                                       else CurrentWIncron.CrontabString:=s;

{    if CurrentWincron.CrontabString='' then CurrentWIncron.CrontabString:=s
                                       else CurrentWIncron.LogfileString:=s}
   end;


  end;
end;


procedure TCronico.GetWinCrons;
var j,i:integer;
    temp:TWinCronWindowEntry;
begin
 while (WinCrons.Count>0) do WinCrons.delete(0);
 WindowLister.GetWindows(GetWindowEntry);

 // sort wnd handles
 for i:= 1 to WinCrons.count do
  for j:= 1 to WinCrons.Count-1 do
   begin
    if TWinCronWindowEntry(Wincrons[j-1]).wnd>TWinCronWindowEntry(Wincrons[j]).wnd then
      begin
       temp:=Wincrons[j-1];
       WinCrons[j-1]:=WinCrons[j];
       WinCrons[j]:=temp;
      end;
   end;

 for i:= 1 to WinCrons.count do
  begin
   CurrentWincron:=TWinCronWindowEntry(Wincrons[i-1]);
   CurrentWinCron.CrontabString:='';
   WindowLister.GetChildWindows(CurrentWincron.wnd,GetChildWindowEntry);
  end;

 if WinCrons.Count=0 then MTimer.Enabled:=false;
 if assigned(OnCheckTimer) then OnCheckTimer(nil);
end;



procedure TCronico.Hide(WinCronWindowEntry:TWinCronWindowEntry);
begin
 if WinCronWindowEntry<>nil then
     ShowWindowAsync(WinCronWindowEntry.wnd,sw_hide);
end;


procedure TCronico.Show(WinCronWindowEntry:TWinCronWindowEntry);
begin
 if WinCronWindowEntry<>nil then
  begin
     ShowWindowAsync(WinCronWindowEntry.wnd,sw_shownormal);
     BringWindowToTop(WinCronWindowEntry.wnd);
     SetForeGroundWIndow(WinCronWindowEntry.wnd);
     MTimer.Enabled:=true;
  end;
end;


procedure TCronico.Kill(WinCronWindowEntry:TWinCronWindowEntry);
begin
 if WinCronWindowEntry<>nil then
  begin
    SendMessage(WInCronWindowEntry.wnd,WM_CLOSE,0,0);
  end;
end;

procedure TCronico.ShowAll;
var i:integer;
begin
 GetWinCrons;
 for i:= 1 to WinCrons.Count do Show(Wincrons[i-1]);
end;


procedure TCronico.HideAll;
var i:integer;
begin
 GetWinCrons;
 for i:= 1 to WinCrons.Count do Hide(Wincrons[i-1]);
 MTimer.Enabled:=false;
end;

procedure TCronico.KillAll;
var i:integer;
begin
 GetWinCrons;
 for i:= 1 to WinCrons.Count do Kill(Wincrons[i-1]);
 MTimer.Enabled:=false;
end;


procedure TCronico.OpenServer;
begin
 TCPServer:=TTCPServer.Create(nil);
 TCPServer.BindIP:=BindIP;
 ReConnectTimer:=TTimer.Create(nil);
 ReConnectTimer.Enabled:=false;
 ReConnectTimer.OnTimer:=ReConnectTimerTimer;
 ReConnectTimer.Interval:=ReConnectInterval;
 StartListen;
end;


procedure TCronico.StartListen;
begin
 TCPServer.Port:=IntToStr(TCPPort);
 TCPServer.OnAccept:=TCPServerAccept;
 TCPServer.Open;
end;


procedure TCronico.StopListen;
begin
 TCPServer.Close;
end;


procedure TCronico.ReConnectTimerTimer(Sender:TObject);
begin
 ReConnectTimer.Enabled:=false;
 StartListen;
end;


procedure TCronico.MinimizeTimerTimer(Sender:TObject);
var anyvisible:boolean;
    i:integer;
    res:integer;
begin
 MTimer.Enabled:=false;
 anyvisible:=false;
 for i:= 1 to WinCrons.Count do
  begin
     res := GetWindowLong(TWindowEntry(WinCrons[i-1]).wnd,GWL_STYLE);
     if ((res and WS_VISIBLE)=WS_VISIBLE) then
     if ((res AND WS_MINIMIZE)=WS_MINIMIZE) then Hide(WinCrons[i-1])
                                            else anyvisible:=true;
  end;
 if not anyvisible then MTimer.Enabled:=false
                   else MTimer.Enabled:=true;
end;



procedure TCronico.CheckTimerTimer(Sender:TObject);
begin
 CheckTimer.Enabled:=false;
 GetWinCrons;
 CheckTimer.Enabled:=true;
end;


procedure TCronico.TCPServerAccept(Sender: TObject; Socket: integer);
var i:integer;
    WinCronWindowEntry:TWinCronWindowEntry;
    m,s:string;
    datum:string;
begin
 if TCPServer.Clients.Count>1 then TCPServer.Disconnect(Socket);

 GetWinCrons;

 Datum:=FormatDateTime(Dateformat,now);

 TCPServer.Write(Socket, '200 '+TCPVersion+CRLF);
 TCPServer.Write(Socket, '201 '+datum+CRLF);
 TCPServer.Write(Socket, '202 '+DateTimeToHex(now)+CRLF);

 if WinCrons.Count<>1 then s:='s' else s:='';
 TCPServer.Write(Socket, '205 '+IntToStr(WinCrons.Count)+' WinCron'+s+' running'+CRLF);

 for i:= 1 to WinCrons.Count do
  begin
   WinCronWindowEntry:=WinCrons[i-1];
   TCPServer.Write(Socket, '300 '+WinCronWindowEntry.status+CRLF);
   s:='301  [';

   if WinCronWindowEntry.checkboxContinueOnError then s:=s+'+' else s:=s+' ';
   s:=s+'] /ContinueOnError'+CRLF;
   TCPserver.write(Socket, s);

   s:='301  [';
   if WinCronWindowEntry.checkboxLog then s:=s+'+' else s:=s+' ';
   s:=s+'] /Log'+CRLF;
   TCPserver.write(Socket, s);
   s:='301  [';
   if WinCronWindowEntry.checkboxNoUpdate then s:=s+'+' else s:=s+' ';
   s:=s+'] /NoUpdate'+CRLF;
   TCPserver.write(Socket, s);

   TCPServer.write(Socket, '301  '+WinCronWIndowEntry.LogFileString+CRLF);
   TCPServer.write(Socket, '301  '+WinCronWIndowEntry.CronTabString+CRLF);


   s:=intTostr(i)+','+WinCronWindowEntry.Status+','+intTostr(WinCronWindowEntry.State)+',';
   if WinCronWindowEntry.checkboxContinueOnError then s:=s+'1' else s:=s+'0';
   s:=s+',';
   if WinCronWindowEntry.checkboxLog then s:=s+'1' else s:=s+'0';
   s:=s+',';
   if WinCronWindowEntry.checkboxNoUpdate then s:=s+'1' else s:=s+'0';
   s:=s+',';
   m:=WinCronWIndowEntry.LogFileString;
   delete(m,1,pos(':',m));
   while (m[1]=' ') do delete(m,1,1);
   s:=s+m+',';
   m:=WinCronWIndowEntry.CronTabString;
   delete(m,1,pos(':',m));
   while (m[1]=' ') do delete(m,1,1);
   s:=s+m;

   TCPServer.write(Socket, '302 '+s+CRLF);
  end;

 TCPServer.Write(Socket, '500 Closing connection'+CRLF);
 TCPServer.Disconnect(Socket);
 StopListen;
 ReConnectTimer.Enabled:=true;
end;


function TCronico.DateTimeToHex(mtime:TDateTime):string;
var p:pByteArray;
    i:integer;
begin
 p:=@mtime;
 Result:='';
 for i:= 1 to sizeof(mTime) do Result:=Result+IntToHex(p[i-1],2);
end;


function TCronico.HexToDateTime(hex:string):TDateTime;
var p:pByteArray;
    c,i:integer;
    m:Byte;
    s:string;

begin
 p:=@result;
 for i:= 1 to sizeof(Result) do
  begin
   s:='$'+copy(hex,1,2);
   delete(hex,1,2);
   val(s,m,c);
   p[i-1]:=m;
  end;
end;


procedure TCronico.Configure(parameter,value:String);
var key:String;
    i,c:integer;
    CheckInterval:integer;
    TCPDelay:integer;
begin
   key:=uppercase(parameter);


   if (key)='/MULTIPLE' then Multiple:=true;
   if (key)='/DATEFORMAT=' then begin
                                 dateformat:=value;
                                 for i:= 1 to length(dateformat) do
                                  if dateformat[i]='_' then dateformat[i]:=' ';
                                end;
   if (key)='/TCP' then TCPPort:=DEF_TCPPort;
   if (key)='/PORT' then TCPPort:=DEF_TCPPort;
   if (key)='/PORT=' then val(value,TCPPort,c);
   if (key)='/NOTCP' then TCPPort:=0;
   if (key)='/BIND=' then BindIP:=value;
   if (key)='/INTERVAL=' then begin
                               val(value,CheckInterval,c);
                               if CheckInterval=0 then CheckInterval:=900;
                               CheckTimer.Interval:=CheckInterval*1000;
                               if value='0' then CheckTimer.enabled:=false;
                              end;
   if (key)='/TCPDELAY=' then begin
                               val(value,TCPDelay,c);
                               if TCPDelay=0 then TCPDelay:=60;
                               TCPDelay:=TCPDelay*1000;
                               ReConnectInterval:=TCPDelay;
                              end;
end;



end.
